<div align="middle">
    <img alt="AoE Logo" src="./images/aoe_logo_01.png" width="320" align="middle">
</div>

[![Build Status](https://travis-ci.org/didi/AoE.svg?branch=master)](https://travis-ci.org/didi/AoE)
[![Android](https://api.bintray.com/packages/aoe/maven/library-core/images/download.svg) ](https://bintray.com/aoe/maven/library-core/_latestVersion)
[![CocoaPods Compatible](https://img.shields.io/cocoapods/v/AoE.svg)](https://cocoapods.org/pods/AoE)
[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://github.com/didi/aoe/blob/master/LICENSE)

 [Documentation](https://didi.github.io/AoE/) |
 [Release Note](./CHANGELOG.md) |
 [Road Map](./ROADMAP.md) |
 [中文](./README.md)

## I. Background
### 1. What is AoE?
**AoE** (AI on Edge) is a drop-open open source **terminal side AI Integrated Runtime Environment (IRE)**. Designed with **"stability, ease of use, security"** to help developers easily deploy deep learning algorithms from different frameworks to the terminal for efficient execution.

Why do you want to make a terminal AI integrated runtime framework? There are two reasons for this:

* **Frame diversity**, with the rapid development of artificial intelligence technology, in the past two years, there have been many inference frameworks running on the terminal, which on the one hand gives developers more choices, on the other hand, it also increases the AI. The cost of deploying to the terminal.
* **The process is cumbersome**. The process of directly accessing AI through the reasoning framework is cumbersome, involving dynamic library access, resource loading, pre-processing, post-processing, resource release, model upgrade, and how to ensure stability.

### 2. Which platforms does AoE support?
Currently, AoE provides Android and iOS implementations. The Linux platform runtime environment SDK is under intense development and is expected to be released at the end of September to facilitate the landing of AI services on smart devices.

## II. Working with documents & examples
- [Android User Guide](./Android/README.md)
- [iOS User Guide](./iOS/README.md)
- [Android Demo](./Android/samples/demo)
- [iOS Demo](./iOS/Demo)
- [More examples](./Catalog.md)

| MNIST | SqueezeNet |
|---|---|
|  <img alt="MNIST" src="./images/mnist_android.jpeg" width="196"> |<img alt="Squeeze" src="./images/squeeze_android.jpeg" width="196">|

## III. Q&A

* `Welcome to submit issues and PRs directly`


## IV. Project members
### Core member

[kuloud](https://github.com/Kuloud)、
[dingc](https://github.com/qtdc1229) 、
[coleman.zou](https://github.com/zouyuefu) 、
[yangke1120](https://github.com/yangke1120) 、
[tangjiaxu](https://github.com/shupiankuaile) 

## V. Friendly link
Another open source project in our department [Dokit](https://github.com/didi/DoraemonKit), a full-featured client (iOS, Android) development assistant, you deserve :)


